/*
 * Copyright 2006-2007 Queplix Corp.
 *
 * Licensed under the Queplix Public License, Version 1.1.1 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.queplix.com/solutions/commercial-open-source/queplix-public-license/
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 *
 */
package com.queplix.qwoss.client.frames.mainframe;

import com.queplix.core.client.frames.mainframe.DefaultOperationStrategy;

/**
 * The handler supports the Routing Rules form.
 *
 * @author Konstantin Mironov
 * @since 12 Feb 2007
 */
class EmailRoutRuleHandler extends OSSOperationStrategy {
    private static final String FROM_ADDRESS_CHECKBOX = "from_address";
    private static final String TO_ADDRESS_CHECKBOX = "to_address";
    private static final String SUBJECT_CHECKBOX = "subject";
    private static final String BODY_CHECKBOX = "body";

    /*
    public Response beforeNew(QForm form) {
        return checkValues(form);
    } // beforeUpdate(QForm) : Response
    */

    /*
    public Response beforeUpdate(QForm form) {
        return checkValues(form);
    } // beforeUpdate(QForm) : Response
    */

    /*private Response checkValues(QForm form) {
        QFormModel qFormModel = form.getModel();
        FieldData fromAddFld = qFormModel.getElementData(FROM_ADDRESS_CHECKBOX);
        FieldData toAddFld = qFormModel.getElementData(TO_ADDRESS_CHECKBOX);
        FieldData subjectFld = qFormModel.getElementData(SUBJECT_CHECKBOX);
        FieldData bodyFld = qFormModel.getElementData(BODY_CHECKBOX);

        boolean isFrom = ((CheckBoxData)fromAddFld).isChecked().booleanValue();
        boolean isTo = ((CheckBoxData)toAddFld).isChecked().booleanValue();
        boolean isSubject = ((CheckBoxData)subjectFld).isChecked().booleanValue();
        boolean isBody = ((CheckBoxData)bodyFld).isChecked().booleanValue();
        boolean isContinue = false;

        // check values
        if (isFrom)
            isContinue = true;
        else if (isTo)
            isContinue = true;
        if (isSubject)
            isContinue = true;
        else if (isBody)
            isContinue = true;

        if (isContinue) {
            return EMPTY_CONTINUE_RESPONSE;
        } else {
            DialogHelper.showModalMessageDialog("Please select at least one filter");
            return EMPTY_BREAK_RESPONSE;
        } // if (isContinue)
    } // checkValues(QForm form) : Response*/
} // class EmailRoutRuleHandler
